#*-* coding: utf-8 *-*
import json
from socket import *
from Communicator import *


class WebCommunicator(Communicator):
    def __init__(self,name):
        Communicator.__init__(self,name)
    def Init(self,ip,port):
        self.IP = str(ip)
        self.Port = int(port)
        Communicator.ResetFlag(self)
    def JsonDatProc(self,dat): 
        from Project import pj 
        req = json.loads(dat) 
        tmp = '';
        if req['id'] == "req-ant-info" :
            if pj.Ant != None : tmp = pj.Ant.GetJson("rep-ant-info")
        elif req['id'] == "req-ant-info" :
            if pj.Ant != None : tmp = pj.Ant.GetJson("rep-ant-info")
        else
            tmp = dat
        self.c.sendall(tmp)
    def Start(self):
        s = socket(AF_INET, SOCK_STREAM)
        s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        s.bind((self.IP, self.Port))
        s.listen(5)
        self.out('Start Listen')
        while 1:
            try: 
                (c, addr) = s.accept() 
                self.c = c
                line = c.recv(1024)
            except: self.out('Receive Error') 
            self.JsonDatProc(line)
            c.close()
            self.SetFlag()
        s.close()
        self.out('Socket Closed(*)')
        

