/*!
 =========================================================
 * KNS - acu-fig.js
 =========================================================
*/

var _DEBUG_OPTION_=false; 
var _start_flag = false;	 
var _transfer_err_cnt = false;	
var timeType = 0;
var _ant_type = 0;
var _ant_name = "Unknown";
var staticFormatIndex=0;

function _check_err(){return _transfer_err_cnt>3};
function _add_err(){_transfer_err_cnt++;};
function _reset_err(){_transfer_err_cnt=0;};
function _(p){return document.getElementById(p);}; 
function _print(p){if(_DEBUG_OPTION_)console.log(p);};
function _event(p){return "*"+p+"?"};
function _append(str){return str+","};
function _appendval(id){return _(id).value+","};
function _appendtxt(id){return _(id).innerHTML+","};
function _appendCaret(str){return str+" <b class='caret'></b>"};
function _endln(){return "\n"};
var noti_types=['info','success','warning','danger'];
function _noti(type,msg){var d = new Date();$(document).ready(function(){$.notify({message: '- '+msg+' ('+d.getFullYear()+'-'+ (d.getMonth()+1)+'-'+ d.getDate()+' '+ d.getHours()+':'+ d.getMinutes()+':'+ d.getSeconds()+')'},{type: noti_types[type],timer: 1000});});}

function IntToHex(dat){ var tmp ="0x",len = 8; hex=parseInt(dat).toString(16).toUpperCase();if(hex.length!=len){ for(i=0;i<(len-hex.length);i++) tmp+="0";} return tmp+hex; }
	

function guid() {
  function s4() {
    return Math.floor((1 + Math.random()) * 0x10000)
      .toString(16)
      .substring(1);
  }
  return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
    s4() + '-' + s4() + s4() + s4();
}

var current_guid="";
function ReadEventLog(){
	/* old
	$.getJSON('/feed/eLogs.json', function(data) {
		try{
			var obj = data;//JSON.parse(data);
			if(obj==null) return;
		}
		catch(e)
		{
			console.log("[Error] ReadEventLog: " + e);
			return;
		}
		var userdata = data;	
		if(current_guid!=userdata.guid)
		{
			if(current_guid!=""){
				var noti_type='success';
				if(userdata.infos[userdata.infos.length-1].name.substring(2,3)=='E') noti_type='warning';
				$(document).ready(function(){
					$.notify({
						icon: 'ti-dashboard',
						message: userdata.infos[userdata.infos.length-1].content

					},{
						type: noti_type,
						timer: 1000
					});
				});
			}
			
			current_guid=userdata.guid;
		}
	});
	*/
	//new 20200828
	
	$.ajax({
		type: "POST",
		async: false,
		url:        "/feed/eLogs.json",
		dataType:   "json", 
		success:    function(data){
		
			try{
				var obj = data;//JSON.parse(data);
				if(obj==null) return;
			}
			catch(e)
			{
				console.log("[Error] ReadEventLog: " + e);
				return;
			}
			var userdata = data;	
			if(current_guid!=userdata.guid)
			{
				if(current_guid!=""){
					var noti_type='success';
					if(userdata.infos[userdata.infos.length-1].name.substring(2,3)=='E') noti_type='warning';
					$(document).ready(function(){
						$.notify({
							icon: 'ti-dashboard',
							message: userdata.infos[userdata.infos.length-1].content

						},{
							type: noti_type,
							timer: 1000
						});
					});
				}
				
				current_guid=userdata.guid;
			}
		}
	});
} 


var PcuErrorTableData = "";
var AcuErrorTableData = "";

function DisplayLedOnly(param){
	
	try{ /* LED Status */
		SetLed("ledRun",param[0]);
		SetLed("ledTrack",param[1]);
		SetLed("ledLock0",param[3]);
		SetLed("ledLock1",param[57]);
		SetLed("ledStaticOn",param[4]);
		SetLed("ledTrackOn",param[5]);
		SetLed("ledSearchOn",param[6]);
		SetLed("ledTxOn",param[2]);
		SetLed("ledGPS",param[58]);
		SetLed("ledMnC",param[52]);
		SetLed("ledAbs",param[53]);
		SetLed("ledTtp",param[54]);
		SetLed("ledErrPcu",parseInt(param[9])>0?2:0);
		SetLed("ledErrAcu",parseInt(param[8])>0?2:0);
		SetLed("ledAsiPass",param[55]);
		
		/*
		var clrs = ["#808080", "#42a084", "#F3BB45","#f97500" ];	
		$('ledStaticOn').css('color', clrs[param[4]]);
		$('ledTrackOn').css('color', clrs[param[5]]);
		$('ledSearchOn').css('color', clrs[param[6]]);
		$('ledTxOn').css('color', clrs[param[2]]);
		*/
		
	}catch(e){
		/* NOP */
	}
	
	try{ /* Antenna Model */
		_ant_type=param[64]; 
		_ant_name=param[65];
		
		var tmp_fc ="";
		if((_ant_type&0x10)==0x10){
			/*
			tmp_fc=FunctionCode[param[79]];
			 _("txtAntName").innerHTML=param[65]!="Unknown"?("<i class='ti-link' style='margin-right:8px;font-size:16px;'></i>"+param[65] +" ("+tmp_fc+")"):
																("<i class='ti-help-alt' style='margin-right:8px'></i>"+param[65]);
			*/
			var IsDualBand = (param[79]&0x10)>0;
			if(IsDualBand == true){
				_("txtAntName").innerHTML=param[65]!="Unknown"?("<i class='ti-link' style='padding:8px;font-size:15px;'></i>"+param[65])://+" (DualBand)"):
																("<i class='ti-help-alt' style='padding:8px;font-size:15px;'></i>"+param[65]);
			}else{
				_("txtAntName").innerHTML=param[65]!="Unknown"?("<i class='ti-link' style='padding:8px;font-size:15px;'></i>"+param[65]):
																("<i class='ti-help-alt' style='padding:8px;font-size:15px;'></i>"+param[65]);
			}
			
		}else{
			var symbol = param[65].substring(0,1);
			var model_val=(param[79]&0x07), model_type = 3;
			switch(model_val){
				case 0: model_type=3; break;
				case 1: model_type=4; break;
				case 2: model_type=5; break;
				case 3: model_type=7; break;
			}
			var band_type = "KU";
			var band_val = (param[79]&0x14)>>3;
			switch(model_val){
				case 0: band_type = "KU"; break;
				case 1: band_type = "KA"; break;
			}
			tmp_fc = symbol+model_type+band_type;
			//console.log(param[79] + " / " + tmp_fc);
			 _("txtAntName").innerHTML=param[65]!="Unknown"?("<i class='ti-link' style='padding:8px;font-size:15px;'></i>"+param[65]):
																("<i class='ti-help-alt' style='padding:8px;font-size:15px;'></i>"+param[65]);
		}
	}catch(e){
		/* NOP */
	}
	
	try{ 
	/* Antenna & ACU Error ***********************************************************/
	/*
			AntTypeUnknown = 0x0000,
			AntTypeAuto = 0x00A0,
			AntTypeOneArm = 0x0010,
			AntTypeMK4 = 0x0010,
			AntTypeMK3M = 0x4010,
			AntType10ULVM = 0x4010,
			AntTypeTwoArms = 0x0020,
			AntTypeCSeries = 0x0020,
			AntTypeC4 = 0x0020,
			AntTypeC5 = 0x0021,
			AntTypeT4 = 0x0020,
			AntTypeESeries = 0x0020,
			AntTypeM4M = 0x4020,
			AntTypeM4 = 0x0120,
			AntTypeTwoArmsWithoutABS = 0x0040, 
			AntTypeKSeries = 0x0040,
	*/
		//_ant_type = 0x4020; 
		var pcu_err_code= param[9];//
		var acu_err_code= param[8];//0x80000000;

		switch(parseInt(_ant_type)){
			case 0x0010: PcuError = PcuErrorForMK; break;
			case 0x4010: PcuError = PcuErrorForMK; break;
			case 0x0020: PcuError = PcuErrorForC; break;
			case 0x0021: PcuError = PcuErrorForC; break;
			case 0x4020: PcuError = PcuErrorForM4M; break;
			case 0x0040: PcuError = PcuErrorForC; break;
			default: PcuError = PcuErrorForMK; break; 
		}
		
		//console.log((pcu_err_code))
		//console.log(IntToHex(pcu_err_code))
		
		
		var Error = "Error Code: "+IntToHex(pcu_err_code)+"\n";
		/*
		for(var i=0;i<=33;i++){
			if((1<<i&parseInt(pcu_err_code))>0){
				Error+=(i+1)+') '+PcuError[i+1] +"\n";
			}
		}
		*/
		_('tipErrPcu').title=Error;
		
		PcuErrorTableData="";
		for(var i=0;i<16;i++){
			
			PcuErrorTableData +="<tr>";
			var idx = i;
			if((1<<idx&parseInt(pcu_err_code))!=0){
				PcuErrorTableData +="<td style='background:#fdb77b'>"+(idx+1)+"</td>"+"<td style='background:#fdb77b'>"+PcuError[(idx+1)]+"</td>";
			}
			else{
				PcuErrorTableData+="<td>"+(idx+1)+"</td>"+"<td>"+PcuError[(idx+1)]+"</td>";
			}
			
			idx += 16;
			if((1<<idx&parseInt(pcu_err_code))!=0){
				PcuErrorTableData +="<td style='background:#fdb77b'>"+(idx+1)+"</td>"+"<td style='background:#fdb77b'>"+PcuError[(idx+1)]+"</td>";
			}
			else{
				PcuErrorTableData+="<td>"+(idx+1)+"</td>"+"<td>"+PcuError[(idx+1)]+"</td>";
			}
			
			PcuErrorTableData +="</tr>";
			
			//console.log(idx);
			//console.log(1<<idx&parseInt(pcu_err_code));
		}
		
		
		Error = "Error Code: "+acu_err_code+"\n";
		for(var i=0;i<=33;i++){
			if((1<<i&parseInt(acu_err_code))>0){
				Error+=(i+1)+') '+AcuError[i+1] +"\n";
			}
		}
		_('tipErrAcu').title=Error;
		
		AcuErrorTableData="";
		for(var i=0;i<16;i++){
			
			AcuErrorTableData +="<tr>";
			var idx = i;
			if((1<<idx&parseInt(acu_err_code))!=0){
				AcuErrorTableData +="<td style='background:#fdb77b'>"+(idx+1)+"</td>"+"<td style='background:#fdb77b'>"+AcuError[(idx+1)]+"</td>";
			}
			else{
				AcuErrorTableData+="<td>"+(idx+1)+"</td>"+"<td>"+AcuError[(idx+1)]+"</td>";
			}
			
			idx += 16;
			if((1<<idx&parseInt(acu_err_code))!=0){
				AcuErrorTableData +="<td style='background:#fdb77b'>"+(idx+1)+"</td>"+"<td style='background:#fdb77b'>"+AcuError[(idx+1)]+"</td>";
			}
			else{
				AcuErrorTableData+="<td>"+(idx+1)+"</td>"+"<td>"+AcuError[(idx+1)]+"</td>";
			}
			
			AcuErrorTableData +="</tr>";
		}
		
		_('tbPcuError').innerHTML = PcuErrorTableData;	
		_('tbAcuError').innerHTML = AcuErrorTableData;	
		_('mdPcuErrorCode').innerHTML = "Error Code: "+pcu_err_code;	
		_('mdAcuErrorCode').innerHTML = "Error Code: "+acu_err_code;
	}catch(e){
		/* NOP */
	}	
	
	
	try{ /* FC Code */
		//Web UI - Static Text Format
		// - MK4 => Static
		// - C Serise => AHBS
		staticFormatIndex=((_ant_type&0x10)!=0x10)?1:0;
		
		//Function Code
		if(param[79]==0x10){
			_('txtFCode').style.hidden = false;
			//_('txtFCode').innerHTML = "DualBand (FCx10)";
		}else{
			_('txtFCode').style.hidden = true;
		}
	}catch(e){
		/* NOP */
	}
	
}

function DisplayLed(param){
	
	DisplayLedOnly(param);
	
	//PCU Update
	if(param[60]=='1')
	{
		window.location.href = "update"
	}
}


function ResetJogActive(el){
	//Remove class
	if (document.getElementById(el).classList.contains('jog-active')){
		document.getElementById(el).classList.remove('jog-active');
	}
}

function SetJogActive(target,els){
	//Remove class
	ResetJogActive(els[0]);
	ResetJogActive(els[1]);
	ResetJogActive(els[2]);
	ResetJogActive(els[3]);
	//Set class
	if(target=='1'){
		document.getElementById(els[0]).classList.add('jog-active');
	}else if(target=='2'){
		document.getElementById(els[1]).classList.add('jog-active');
	}else if(target=='3'){
		document.getElementById(els[2]).classList.add('jog-active');
	}else if(target=='4'){
		document.getElementById(els[3]).classList.add('jog-active');
	}
}

//--------------------------------------------------------------------
//Time
function formatDateWithoutSec(date) {
  return date.getFullYear() + '-' + 
	(date.getMonth()<10?"0":"")+date.getMonth() + '-' + 
	(date.getDate()<10?"0":"")+date.getDate() + ' ' + 
	(date.getHours()<10?"0":"")+date.getHours() + ':' + 
	(date.getMinutes()<10?"0":"")+date.getMinutes() + ':';
}

function GetSelectedTime(datetime){
	
	if(timeType==0){
		var offset = new Date().getTimezoneOffset();
		
		var div_dt = datetime.split(" ");
		var date = div_dt[0].split("-");	
		var time = div_dt[1].split(":");
		var target = new Date(date[0],date[1],date[2],time[0],time[1]);
		var local = target.getTime()-(offset*60*1000);

		return formatDateWithoutSec(new Date(local))+time[2];
	}else{
		return datetime;
	}
}


//--------------------------------------------------------------------
//Error
var PcuError;

//Cover - Loading 
var ConnectionCnt = 0xFFFF;
function ResetConnection(){ConnectionCnt=0;}
function CheckConnection(idx){
	ConnectionCnt++;
	if(ConnectionCnt > idx){
		_('cover').style.display = 'block';
	}else{
		_('cover').style.display = 'none';
	}
}
 
var CwMsgFlag=false;
var CwMsgCnt=0;
var CwMsgSetCnt=0;
var CwMsgIntervalCnt=0;
var CwMsgVal=0;
var CwMsg="";
function SetCwMsg(msg,val){CwMsg=msg;CwMsgCnt=val;CwMsgSetCnt=val;CwMsgFlag=true;CwMsgVal=val;}
function DoCwMsg(interval){
	if(CwMsgFlag){
		if(_('cover').style.display=='none') _('cover').style.display = 'block';
		var temp = CwMsg + ' ... ' + CwMsgCnt + ' sec';
		//_('txtCwMsg').innerHTML= temp;
		_('txtCwMsg').innerHTML= CwMsg+ ' (Takes ' + CwMsgVal + ' sec.)';
	}else{
		CwMsgCnt=0;
		CwMsgSetCnt=0;
		return;
	}
		
	if(++CwMsgIntervalCnt>=interval) CwMsgCnt--, CwMsgIntervalCnt=0;

	if(CwMsgCnt<0 || (ConnectionCnt<2&((CwMsgSetCnt-CwMsgCnt)>2)))
	{
		CwMsgFlag=false;
		CwMsg="";
		_('txtCwMsg').innerHTML= "";
	}
}



function _status(id,msg)
{
	var d = new Date();
	_(id).innerHTML='<i class="ti-reload" ></i> '+msg+' ('+d.getFullYear()+'-'+ (d.getMonth()+1)+'-'+ d.getDate()+' '+ d.getHours()+':'+ d.getMinutes()+':'+ d.getSeconds()+')';
}
var syscon_cnt=0;
function _status_connect()
{
	try{
		syscon_cnt++;
		syscon_cnt=syscon_cnt%3;
		var temp=syscon_cnt==0?'.':syscon_cnt==1?'..':syscon_cnt==2?'...':'.';
		var d = new Date();
		_('StatConnect').innerHTML='Synced'+temp+' ('+d.getFullYear()+'-'+ (d.getMonth()+1)+'-'+ d.getDate()+' '+ d.getHours()+':'+ d.getMinutes()+':'+ d.getSeconds()+')';
	}catch(e){
		/* NOP */
	}
}

function ActivateLedIcon(id, val){
	var clrs = ["#808080", "#42a084", "#F3BB45","#f97500" ];	
	$('#'+id).css('color', clrs[val]);
}

function SetLed(el,val){
	ActivateLedIcon(el, val);
	/* old style, version < 0.786
	try{
		//Remove class
		if (document.getElementById(el).classList.contains('text-muted')){
			document.getElementById(el).classList.remove('text-muted');
		}else if(document.getElementById(el).classList.contains('text-success')){
			document.getElementById(el).classList.remove('text-success');
		}else if(document.getElementById(el).classList.contains('text-warning')){
			document.getElementById(el).classList.remove('text-warning');
		}
		//Set class
		if(val=='1'){
			document.getElementById(el).classList.add('text-success');
		}else if(val=='2'){
			document.getElementById(el).classList.add('text-warning');
		}else{
			document.getElementById(el).classList.add('text-muted');
		}
	}catch(e){
	}
	*/
}


function SetStaticFormat(idx, val)
{
	try{
		_("txtStaticFormat"+idx).innerHTML = staticFormat[val]; 
	}catch(e){
		/* NOP */
	}
}


/*!
 ==================================================================================================================
 * Paper Dashboard - v1.2.0
 ==================================================================================================================

*/

var fixedTop = false;
var transparent = true;
var navbar_initialized = false;
var mobile_menu_initialized = false;

$(document).ready(function(){
    window_width = $(window).width();

    // Init navigation toggle for small screens
    if(window_width <= 991){
        pd.initRightMenu();
    }

    //  Activate the tooltips
    $('[rel="tooltip"]').tooltip();

});

$(document).on('click', '.navbar-toggle', function(){
  $toggle = $(this);
  if(pd.misc.navbar_menu_visible == 1) {
    $('html').removeClass('nav-open');
    pd.misc.navbar_menu_visible = 0;
    $('#bodyClick').remove();
    setTimeout(function(){
      $toggle.removeClass('toggled');
    }, 400);
  } else {
    setTimeout(function(){
      $toggle.addClass('toggled');
    }, 430);

    div = '<div id="bodyClick"></div>';
    $(div).appendTo("body").click(function() {
      $('html').removeClass('nav-open');
      pd.misc.navbar_menu_visible = 0;
      $('#bodyClick').remove();
      setTimeout(function(){
        $toggle.removeClass('toggled');
      }, 400);
    });

    $('html').addClass('nav-open');
    pd.misc.navbar_menu_visible = 1;
  }
});

// activate collapse right menu when the windows is resized
$(window).resize(function(){
    if($(window).width() <= 991){
        pd.initRightMenu();
    }
});

pd = {
    misc:{
        navbar_menu_visible: 0
    },
    checkScrollForTransparentNavbar: debounce(function() {
        if($(document).scrollTop() > 381 ) {
            if(transparent) {
                transparent = false;
                $('.navbar-color-on-scroll').removeClass('navbar-transparent');
                $('.navbar-title').removeClass('hidden');
            }
        } else {
            if( !transparent ) {
                transparent = true;
                $('.navbar-color-on-scroll').addClass('navbar-transparent');
                $('.navbar-title').addClass('hidden');
            }
        }
    }),
    initRightMenu: debounce(function() {
        var $sidebar_wrapper = $('.sidebar-wrapper');
        var $sidebar = $('.sidebar');

        if (!mobile_menu_initialized) {
            var $navbar = $('nav').find('.navbar-collapse').children('.navbar-nav');

            mobile_menu_content = '';

            nav_content = $navbar.html();

            //nav_content = '<ul class="nav nav-mobile-menu">' + nav_content + '</ul>';

            $sidebar_nav = $sidebar_wrapper.find(' > .nav');

            // insert the navbar form before the sidebar list
            $sidebar.addClass('off-canvas-sidebar');
            $nav_content = $(nav_content);
            $nav_content.insertBefore($sidebar_nav);

            $(".sidebar-wrapper .dropdown .dropdown-menu > li > a").click(function(event) {
                event.stopPropagation();

            });

            // simulate resize so all the charts/maps will be redrawn
            window.dispatchEvent(new Event('resize'));

            mobile_menu_initialized = true;
        } else {
            if ($(window).width() > 991) {
                // reset all the additions that we made for the sidebar wrapper only if the screen is bigger than 991px
                $sidebar_wrapper.find('.nav-mobile-menu').remove();
                $sidebar.removeClass('off-canvas-sidebar');

                mobile_menu_initialized = false;
            }
        }
    }, 200)
}


// Returns a function, that, as long as it continues to be invoked, will not
// be triggered. The function will be called after it stops being called for
// N milliseconds. If `immediate` is passed, trigger the function on the
// leading edge, instead of the trailing.

function debounce(func, wait, immediate) {
	var timeout;
	return function() {
		var context = this, args = arguments;
		clearTimeout(timeout);
		timeout = setTimeout(function() {
			timeout = null;
			if (!immediate) func.apply(context, args);
		}, wait);
		if (immediate && !timeout) func.apply(context, args);
	};
};


